﻿using System;
using System.Collections.Generic;
using System.Text;
using Windows.ApplicationModel;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Microsoft.Xaml.Interactivity;

namespace Todolist.Behaviors
{
    public class TextBoxBehavior : DependencyObject, IBehavior
    {
        public DependencyObject AssociatedObject { get; private set; }

        public void Attach(DependencyObject associatedObject)
        {
            if (associatedObject != AssociatedObject 
                && !DesignMode.DesignModeEnabled)
            {
                if (AssociatedObject != null)
                    throw new InvalidOperationException("Cannot attach behavior multiple times.");

                AssociatedObject = associatedObject;
                var control = AssociatedObject as TextBox;
                if (control == null)
                {
                    throw new InvalidOperationException("Cannot attach behavior you must have TextBox.");
                }
                control.TextChanged += control_TextChanged;
            }
        }

        void control_TextChanged(object sender, TextChangedEventArgs e)
        {
            var tb = (TextBox)sender;
            var textBinding = tb.GetBindingExpression(TextBox.TextProperty);
            if (textBinding == null) return;
            textBinding.UpdateSource();
        }

        public void Detach()
        {
            ((TextBox) AssociatedObject).TextChanged -= control_TextChanged;
        }
    }
}
